using System;
using Styx;
using Styx.Plugins;
using System.Linq;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.CommonBot;
using System.Diagnostics;

namespace MrFetcher {
    public class MrFetcher : HBPlugin {
        public override string Name { get { return "MrFetcher"; } }

        public override string Author { get { return "maybe, recode by AknA"; } }

        public override Version Version { get { return new Version(1, 0, 0, 0); } }

        private readonly Stopwatch _lootTimer = new Stopwatch();

        public override void Pulse() {
            if(_lootTimer.ElapsedMilliseconds < 2500) {
                return;
            }

            if(SpellManager.GlobalCooldown || !StyxWoW.Me.IsAlive || StyxWoW.Me.Combat || !SpellManager.CanCast(125050)) {
                return;
            }

            var ret = ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Where(u => u.Lootable && u.IsDead && u.InLineOfSight && u.Distance < 40).OrderBy(u => u.Distance).FirstOrDefault();
            if(ret == null) {
                return;
            }

            if(!SpellManager.CanCast("125050")) {
                return;
            }

            ret.Target();
            WoWMovement.MoveStop();
            SpellManager.Cast("125050");
            _lootTimer.Restart();
        }
    }
}